<?php
Class AdminModel
{
 /****************************************************************************
  * settings_link( $links )                                                  *
  *                                                                          *
  * Add settings link on plugin page                                         *
  ****************************************************************************/
  public function settings_link($links) 
  { 
    $settings_link = '<a href="options-general.php?page=stripe-settings.php">Settings</a>'; 
    array_unshift($links, $settings_link); 
    return $links; 
  }

 /***************************************************************************
  * add_javascript()                                                        *
  ***************************************************************************/
  public  function add_javascript()
  {
    DebugModel::debug('add_javascript()');
    //We can include as many Javascript files as we want here.
    wp_enqueue_script('pluginscript', 
                      STRIPE_BASE_URL . '/include/js/stripe-settings.js', 
                      array('jquery'));
  }
 /***************************************************************************
  * register_settings()
  **************************************************************************/
  public function register_settings() 
  {
    DebugModel::debug('register_settings()');
  	// creates our settings in the options table
	  register_setting('stripe_settings_group', 'stripe_settings');
  }
 /***************************************************************************
  * save_stripe_customer_id( $user_id )                                     *
  **************************************************************************/
  public function save_stripe_customer_id( $user_id ) 
  {
    if (!current_user_can( 'edit_user', $user_id )) return FALSE;
    update_usermeta( $user_id, '_stripe_customer_id', 
                     $_POST['_stripe_customer_id'] );
  }
 /***************************************************************************
  * post_payment_to_remote( $controller )                                   *
  **************************************************************************/
  public function post_payment_to_remote( $controller )
  {
    $controller->debug( 'post_payment_to_remote( $controller )' );
    $curl_handle = curl_init();
    curl_setopt($curl_handle, CURLOPT_URL, $controller->get_upgrade_server());
    curl_setopt($curl_handle, CURLOPT_POST, 1);
    $post_fields = "adminEmail=" . $controller->get_admin_email() . "&" 
                 . "amount=" . $controller->get_amount() . "&"
                 . "product_id=" . $controller->get_product_id() . "&"
                 . "description=" . $controller->get_description() . "&"
                 . "stripeToken=" . $controller->get_stripe_token();
    curl_setopt($curl_handle, CURLOPT_POSTFIELDS, $post_fields );
    curl_setopt($curl_handle, CURLOPT_RETURNTRANSFER, true);
    $controller->set_remote_response( curl_exec( $curl_handle ) );
    $controller->set_response_info( curl_getinfo( $curl_handle ) );
    curl_close($curl_handle);
  }
}
?>
